(defun c:E2POL ()
  ;; Cargar las funciones de Visual LISP y establecer la biblioteca de Excel
  (vl-load-com)
  (setq tlbfile (findfile "C:\\Program Files\\Microsoft Office\\root\\Office16\\EXCEL.EXE"))
  (vlax-import-type-library :tlb-filename tlbfile :methods-prefix "msxl-" :properties-prefix "msxl-" :constants-prefix "msxl-")

  ;; Abrir la hoja de cálculo de Excel y encontrar la hoja actual
  (setq xfile "H:\\BBB.xls")
  (cond
    ((setq fn (findfile xfile))
      (cond
        ((setq appsession (vlax-get-or-create-object "Excel.Application"))
          (vlax-invoke-method (vlax-get-property appsession 'workbooks) 'open fn)
          (vla-put-visible appsession 0)
        )
      )
    )
    (t (alert (strcat "Cannot locate source file: " xfile)))
  )
  (setq xlapp appsession)
  (setq rng (msxl-get-activesheet xlapp))

  ;; Leer configuraciones de altura y color
  (setq text-height (vlax-variant-value (msxl-get-value (vlax-variant-value (msxl-get-item (msxl-get-cells rng) (vlax-make-variant 1) (vlax-make-variant 4))))))
  (setq polyline-color (vlax-variant-value (msxl-get-value (vlax-variant-value (msxl-get-item (msxl-get-cells rng) (vlax-make-variant 2) (vlax-make-variant 4))))))

  ;; Leer las coordenadas de los puntos y los textos desde la hoja de cálculo de Excel
  (setq i 1 points '() texts '())
  (while (not (null (vlax-variant-value (msxl-get-value (vlax-variant-value (msxl-get-item (msxl-get-cells rng) (vlax-make-variant i) (vlax-make-variant 1)))))))
    (setq x (vlax-variant-value (msxl-get-value (vlax-variant-value (msxl-get-item (msxl-get-cells rng) (vlax-make-variant i) (vlax-make-variant 1))))))
    (setq y (vlax-variant-value (msxl-get-value (vlax-variant-value (msxl-get-item (msxl-get-cells rng) (vlax-make-variant i) (vlax-make-variant 2))))))
    (setq text (vlax-variant-value (msxl-get-value (vlax-variant-value (msxl-get-item (msxl-get-cells rng) (vlax-make-variant i) (vlax-make-variant 3))))))
    (setq points (append points (list (list x y 0))))
    (setq texts (append texts (list text)))
    (setq i (+ i 1))
  )

  ;; Cerrar Excel
  (vlax-invoke-method (vlax-get-property xlapp "ActiveWorkbook") "Close" :vlax-false)
  (vlax-invoke-method xlapp "Quit")
  (vlax-release-object xlapp)
  (gc)

  ;; Crear un polígono cerrado en AutoCAD usando las coordenadas importadas
  (command "" "color" polyline-color)
  (command "._pline")
  (foreach point points
    (command (strcat (rtos (car point) 2 8) "," (rtos (cadr point) 2 8)))
  )
  (command "c" "")
  
  ;; Colocar texto en cada punto con configuraciones especificadas
  (foreach p (mapcar 'list points texts)
    (command "._text" (strcat (rtos (caar p) 2 8) "," (rtos (cadar p) 2 8)) text-height "0" (cadr p))
  )

  (princ)
)
.0